(function() {
  var $fyBuilder, Animation, EVENTS, JQueryAdapter, cancelable_and_retrivable_callbacks, createSpaceholder, defaultfn, deferred_callbacks, defineJQueryAPI, isArray, jqueryify, removed, singlton_callback, _ref;

  Animation = require('animation').Animation;

  _ref = require('./util'), singlton_callback = _ref.singlton_callback, deferred_callbacks = _ref.deferred_callbacks, cancelable_and_retrivable_callbacks = _ref.cancelable_and_retrivable_callbacks, defineJQueryAPI = _ref.defineJQueryAPI, $fyBuilder = _ref.$fyBuilder, createSpaceholder = _ref.createSpaceholder, removed = _ref.removed;

  defaultfn = require('./fn');

  isArray = Array.isArray;

  EVENTS = ['add', 'end', 'show', 'hide', 'attr', 'text', 'raw', 'remove', 'replace'];

  JQueryAdapter = (function() {

    function JQueryAdapter(template, opts) {
      var f, n, plugin, _base, _i, _len, _ref10, _ref11, _ref12, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
      this.template = template;
      if (opts == null) opts = {};
      this.builder = (_ref2 = this.template.xml) != null ? _ref2 : this.template;
      if ((_ref3 = opts.timeoutexecution) == null) opts.timeoutexecution = '32ms';
      if ((_ref4 = opts.execution) == null) opts.execution = '8ms';
      if ((_ref5 = opts.timeout) == null) opts.timeout = '120ms';
      if ((_ref6 = opts.toggle) == null) opts.toggle = true;
      if ((_ref7 = this.$) == null) {
        this.$ = (_ref8 = (_ref9 = opts.jquery) != null ? _ref9 : opts.$) != null ? _ref8 : typeof window !== "undefined" && window !== null ? window.$ : void 0;
      }
      this.animation = new Animation(opts);
      this.animation.start();
      this.fn = {};
      for (n in defaultfn) {
        f = defaultfn[n];
        if ((_ref10 = (_base = this.fn)[n]) == null) _base[n] = f.bind(this);
      }
      this.initialize();
      if ((_ref11 = opts.use) == null) opts.use = [];
      if (!isArray(opts.use)) opts.use = [opts.use];
      _ref12 = opts.use;
      for (_i = 0, _len = _ref12.length; _i < _len; _i++) {
        plugin = _ref12[_i];
        this.use(plugin);
      }
    }

    JQueryAdapter.prototype.initialize = function() {
      var old_query;
      this.listen();
      this.builder._jquery = this.$([]);
      this.builder._jquery_done = deferred_callbacks();
      this.builder._jquery_done.callback()();
      old_query = this.builder.query;
      this.builder.query = function(type, tag, key) {
        var attr, attrs, domel, _i, _len, _ref2;
        if (tag._jquery == null) return old_query.call(this, type, tag, key);
        if (type === 'attr') {
          return tag._jquery.attr(key);
        } else if (type === 'text') {
          return tag._jquery.text();
        } else if (type === 'tag') {
          if (key._jquery != null) {
            return key;
          } else {
            if ((domel = key[0]) != null) {
              attrs = {};
              _ref2 = domel.attributes;
              for (_i = 0, _len = _ref2.length; _i < _len; _i++) {
                attr = _ref2[_i];
                attrs[attr.name] = attr.value;
              }
              return new this.builder.Tag(domel.nodeName.toLowerCase(), attrs, function() {
                this._jquery = key;
                return this.end();
              });
            } else {
              return old_query.call(this, type, tag, key);
            }
          }
        }
      };
      return this.template.register('ready', function(tag, next) {
        if (tag._jquery_ready === true) {
          return next(tag);
        } else {
          return tag._jquery_ready = function() {
            return next(tag);
          };
        }
      });
    };

    JQueryAdapter.prototype.use = function(plugin) {
      if (plugin != null) plugin.call(this, this);
      return this;
    };

    JQueryAdapter.prototype.listen = function() {
      var _this = this;
      return EVENTS.forEach(function(event) {
        return _this.template.on(event, _this["on" + event].bind(_this));
      });
    };

    JQueryAdapter.prototype.onadd = function(parent, el) {
      var cb, ecb, pcb, that, _base, _base2, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7, _ref8, _ref9;
      if (removed(el)) return;
      if (el === el.builder) {
        if ((_ref2 = el._jquery) == null) {
          el._jquery = this.$([], (_ref3 = el.parent) != null ? _ref3._jquery : void 0);
        }
        $fyBuilder(el);
      } else {
        if ((_ref4 = el._jquery) == null) {
          el._jquery = this.$(el.toString(), el.parent._jquery);
        }
        defineJQueryAPI(el);
      }
      that = this;
      if ((_ref5 = el._jquery_manip) == null) {
        el._jquery_manip = cancelable_and_retrivable_callbacks();
      }
      if ((_ref6 = el._jquery_done) == null) {
        el._jquery_done = deferred_callbacks();
      }
      if ((_ref7 = parent._jquery_done) == null) {
        parent._jquery_done = deferred_callbacks();
      }
      el._jquery_manip.reset();
      while ((cb = el._jquery_manip.callbacks.shift()) != null) {
        this.animation.push(cb);
      }
      ecb = el._jquery_done.callback();
      pcb = parent._jquery_done.callback();
      if (el === el.builder) {
        ecb();
      } else {
        el.ready(ecb);
      }
      if (parent === parent.builder) {
        pcb();
      } else {
        parent.ready(pcb);
      }
      if ((_ref8 = el._jquery_insert) == null) {
        el._jquery_insert = singlton_callback(el, function() {
          if (this._jquery.length === 0) {
            createSpaceholder.call(that, this, this.parent._jquery);
          }
          that.fn.add(this.parent, this);
          if (this.parent._jquery_wrapped) {
            this.parent._jquery_wrapped = false;
            this.parent._jquery = this.parent._jquery.not(':first');
          }
          if (this.parent === this.parent.builder) $fyBuilder(this.parent);
          if (typeof this._jquery_ready === "function") this._jquery_ready();
          this._jquery_ready = true;
          return this._jquery_insert = true;
        });
      }
      if (typeof (_base = el._jquery_insert).replace === "function") {
        _base.replace(el);
      }
      if ((_ref9 = el._jquery_parent_done) == null) {
        el._jquery_parent_done = singlton_callback(el, function() {
          var bool, _ref10, _ref11;
          if (removed(this)) return;
          if (this.parent === this.parent.builder) {
            bool = !(this.parent.parent != null) || (this.parent.parent === ((_ref10 = this.parent.parent) != null ? _ref10.builder : void 0) && ((_ref11 = this.parent.parent) != null ? _ref11._jquery_insert : void 0) === true);
            if (bool && this.parent._jquery_insert === true) {
              return that.animation.push(this._jquery_insert);
            } else {
              return typeof this._jquery_insert === "function" ? this._jquery_insert() : void 0;
            }
          } else {
            return that.animation.push(this._jquery_insert);
          }
        });
      }
      if (typeof (_base2 = el._jquery_parent_done).replace === "function") {
        _base2.replace(el);
      }
      return parent._jquery_done(el._jquery_parent_done);
    };

    JQueryAdapter.prototype.onreplace = function(oldtag, newtag) {
      var cb, oldreplacerequest, that, _base, _ref2, _ref3, _ref4, _ref5, _ref6, _ref7;
      if (removed(oldtag) || removed(newtag)) return;
      if ((_ref2 = newtag._jquery_parent_done) == null) {
        newtag._jquery_parent_done = oldtag._jquery_parent_done;
      }
      if ((_ref3 = newtag._jquery_insert) == null) {
        newtag._jquery_insert = oldtag._jquery_insert;
      }
      if ((_ref4 = newtag._jquery_done) == null) {
        newtag._jquery_done = oldtag._jquery_done;
      }
      oldtag._jquery_parent_done = null;
      oldtag._jquery_insert = null;
      oldtag._jquery_done = null;
      this.onadd(oldtag.parent, newtag);
      if ((_ref5 = oldtag._jquery_manip) != null) {
        if (typeof _ref5.cancel === "function") _ref5.cancel();
      }
      newtag._jquery_manip.reset();
      while ((cb = newtag._jquery_manip.callbacks.shift()) != null) {
        this.animation.push(cb);
      }
      if (newtag._jquery_insert === true) {
        that = this;
        if ((_ref6 = newtag._jquery_replace) == null) {
          newtag._jquery_replace = oldtag._jquery_replace;
        }
        oldreplacerequest = newtag._jquery_replace != null;
        if ((_ref7 = newtag._jquery_replace) == null) {
          newtag._jquery_replace = singlton_callback(newtag, function() {
            if (this._jquery.length === 0) {
              createSpaceholder.call(that, this, this.parent._jquery);
            }
            that.fn.replace(oldtag, this);
            if (this === this.builder) return $fyBuilder(this);
          });
        }
        if (typeof (_base = newtag._jquery_replace).replace === "function") {
          _base.replace(newtag);
        }
        oldtag._jquery_replace = null;
        if (!oldreplacerequest) return this.animation.push(newtag._jquery_replace);
      }
    };

    JQueryAdapter.prototype.ontext = function(el, text) {
      var _ref2;
      var _this = this;
      if ((_ref2 = el._jquery_manip) == null) {
        el._jquery_manip = cancelable_and_retrivable_callbacks(true);
      }
      return this.animation.push(el._jquery_manip(function() {
        return _this.fn.text(el, text);
      }));
    };

    JQueryAdapter.prototype.onraw = function(el, html) {
      var _ref2;
      var _this = this;
      if ((_ref2 = el._jquery_manip) == null) {
        el._jquery_manip = cancelable_and_retrivable_callbacks(true);
      }
      return this.animation.push(el._jquery_manip(function() {
        return _this.fn.raw(el, html);
      }));
    };

    JQueryAdapter.prototype.onattr = function(el, key, value) {
      var _ref2;
      var _this = this;
      if ((_ref2 = el._jquery_manip) == null) {
        el._jquery_manip = cancelable_and_retrivable_callbacks(true);
      }
      return this.animation.push(el._jquery_manip(function() {
        return _this.fn.attr(el, key, value);
      }));
    };

    JQueryAdapter.prototype.onshow = function(el) {
      if (el._jquery != null) return this.fn.show(el);
    };

    JQueryAdapter.prototype.onhide = function(el) {
      if (el._jquery != null) return this.fn.hide(el);
    };

    JQueryAdapter.prototype.onremove = function(el, opts) {
      var _ref2, _ref3, _ref4;
      if (el._jquery == null) return;
      this.fn.remove(el, opts);
      if ((_ref2 = el._jquery_parent_done_done) != null) _ref2.reset();
      if ((_ref3 = el._jquery_done) != null) _ref3.reset();
      if ((_ref4 = el._jquery_manip) != null) _ref4.cancel();
      delete el._jquery_parent_done;
      delete el._jquery_replace;
      delete el._jquery_insert;
      if (!opts.soft) {
        delete el._jquery_manip;
        delete el._jquery_done;
        return delete el._jquery;
      }
    };

    JQueryAdapter.prototype.onend = function() {
      this.template.jquery = this.template._jquery = this.builder._jquery;
      return defineJQueryAPI(this.template);
    };

    return JQueryAdapter;

  })();

  jqueryify = function(opts, tpl) {
    var _ref2;
    if (tpl == null) _ref2 = [opts, null], tpl = _ref2[0], opts = _ref2[1];
    new JQueryAdapter(tpl, opts);
    return tpl;
  };

  jqueryify.fn = defaultfn;

  jqueryify.Adapter = JQueryAdapter;

  module.exports = jqueryify;

  if (process.title === 'browser') {
    (function() {
      if (this.dynamictemplate != null) {
        return this.dynamictemplate.jqueryify = jqueryify;
      } else {
        return this.dynamictemplate = {
          jqueryify: jqueryify
        };
      }
    }).call(window);
  }

}).call(this);
