(function() {
  var $fyBuilder, cancelable_and_retrivable_callbacks, createSpaceholder, deferred_callbacks, defineJQueryAPI, removed, singlton_callback;

  singlton_callback = function(that, callback) {
    var req;
    req = function() {
      return callback != null ? callback.apply(that, arguments) : void 0;
    };
    req.replace = function(replacement) {
      return that = replacement;
    };
    return req;
  };

  deferred_callbacks = function() {
    var allowed, callbacks, done, res;
    done = false;
    callbacks = [];
    res = function(cb) {
      if (done) return typeof cb === "function" ? cb() : void 0;
      return callbacks.push(cb);
    };
    allowed = null;
    res.callback = function() {
      var callback;
      if (done) return (function() {});
      callback = function() {
        var cb;
        if (callback === allowed) {
          while ((cb = callbacks.shift()) != null) {
            if (typeof cb === "function") cb.apply(null, arguments);
          }
          callbacks = null;
          allowed = null;
          return done = true;
        }
      };
      allowed = callback;
      return callback;
    };
    res.reset = function() {
      allowed = null;
      callbacks = [];
      return done = false;
    };
    return res;
  };

  cancelable_and_retrivable_callbacks = function(canceled) {
    var res;
    if (canceled == null) canceled = false;
    res = function(cb) {
      return function() {
        if (canceled) {
          return res.callbacks.push(cb);
        } else {
          return typeof cb === "function" ? cb.apply(null, arguments) : void 0;
        }
      };
    };
    res.cancel = function() {
      return canceled = true;
    };
    res.reset = function() {
      return canceled = false;
    };
    res.callbacks = [];
    return res;
  };

  defineJQueryAPI = function(el) {
    el.__defineGetter__('selector', function() {
      return el._jquery.selector;
    });
    return el.__defineGetter__('context', function() {
      return el._jquery.context;
    });
  };

  $fyBuilder = function(builder) {
    var $builder;
    $builder = builder._jquery;
    builder.jquery = $builder;
    builder.template.jquery = $builder;
    builder.template._jquery = $builder;
    defineJQueryAPI(builder.template);
    return defineJQueryAPI(builder);
  };

  createSpaceholder = function(el, $par) {
    el._jquery = this.$('<spaceholder>', $par);
    el._jquery_wrapped = true;
    if (el === el.builder) {
      return $fyBuilder(el);
    } else {
      return defineJQueryAPI(el);
    }
  };

  removed = function(el) {
    return el.closed === "removed";
  };

  module.exports = {
    singlton_callback: singlton_callback,
    deferred_callbacks: deferred_callbacks,
    cancelable_and_retrivable_callbacks: cancelable_and_retrivable_callbacks,
    createSpaceholder: createSpaceholder,
    defineJQueryAPI: defineJQueryAPI,
    $fyBuilder: $fyBuilder,
    removed: removed
  };

}).call(this);
